SystemOrganization addCategory: #TADP!

Trait named: #Atacante
	uses: {}
	category: 'TADP'!

!Atacante methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 18:09'!
atacarA: unGuerrero
	(self potencialOfensivo > unGuerrero potencialDefensivo) ifTrue: [unGuerrero recibirDanio: self potencialOfensivo - unGuerrero  potencialDefensivo]! !

Trait named: #Defensor
	uses: {}
	category: 'TADP'!

!Defensor methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 18:19'!
recibirDanio: danio
	(self energia>danio) 
 		ifTrue: [ self energia: self energia - danio]
  		ifFalse:[ self energia: 0]
! !

Object subclass: #Espada
	instanceVariableNames: 'potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

!Espada methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:42'!
potencia
	^ potencia! !

!Espada methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:41'!
potencia: anObject
	potencia := anObject! !

Object subclass: #Guerrero
	uses: Atacante + Defensor
	instanceVariableNames: 'potencialOfensivo potencialDefensivo energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

Guerrero class
	uses: Atacante classTrait + Defensor classTrait
	instanceVariableNames: ''!

Guerrero subclass: #Espadachin
	instanceVariableNames: 'espada habilidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

!Espadachin methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:43'!
espada
	^ espada! !

!Espadachin methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:43'!
espada: anObject
	espada := anObject! !

!Espadachin methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:43'!
habilidad
	^ habilidad! !

!Espadachin methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:43'!
habilidad: anObject
	habilidad := anObject! !

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 17:44'!
potencialOfensivo
	^self espada potencia * self habilidad + super potencialOfensivo! !

!Guerrero methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:25'!
energia
	^ energia! !

!Guerrero methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:25'!
energia: anObject
	energia := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:23'!
potencialDefensivo
	^ potencialDefensivo! !

!Guerrero methodsFor: 'accessing' stamp: 'Edu 4/5/2013 17:23'!
potencialDefensivo: anObject
	potencialDefensivo := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 17:57'!
potencialOfensivo
	^potencialOfensivo! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 17:55'!
potencialOfensivo: unPotencialOfensivo
	potencialOfensivo := unPotencialOfensivo! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 15:42'!
saludar
	^'Hola'! !

Object subclass: #Misil
	uses: Atacante
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

Misil class
	uses: Atacante classTrait
	instanceVariableNames: ''!

!Misil methodsFor: 'as yet unclassified' stamp: 'Edu 4/5/2013 17:57'!
potencialOfensivo
	^1000! !

Object subclass: #Muralla
	uses: Defensor
	instanceVariableNames: 'potencialDefensivo energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

Muralla class
	uses: Defensor classTrait
	instanceVariableNames: ''!

!Muralla methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:17'!
energia
	^ energia! !

!Muralla methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:17'!
energia: anObject
	energia := anObject! !

!Muralla methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:18'!
potencialDefensivo
	^ potencialDefensivo! !

!Muralla methodsFor: 'accessing' stamp: 'Edu 4/5/2013 18:18'!
potencialDefensivo: anObject
	potencialDefensivo := anObject! !

Object subclass: #Natural
	instanceVariableNames: 'valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:59'!
divisiblePor: unNumero 
	^((self valor \\ unNumero) == 0)
! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:10'!
divisores
	|divisores|
	divisores := Bag new.
	1 to: self valor do: [:unPosibleDivisor |
		 (self divisiblePor: unPosibleDivisor) ifTrue: [divisores add: unPosibleDivisor].
	].
	^divisores.! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:20'!
esPerfecto
	^self valor == self sumatoriaDeDivisores! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:12'!
esPrimo
	^(self divisores size == 2)! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:35'!
primerosPerfectos
	|unNatural primerosPerfectos|
	unNatural := Natural new.
	primerosPerfectos  := Bag new.
	
	1 to: self valor do: [ :i | 
		unNatural valor: i.
		(unNatural esPerfecto) ifTrue: [primerosPerfectos add: i]	
	].
	^primerosPerfectos.! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:24'!
sumatoriaDeDivisores
	^ (self divisores inject: 0 into: [ :suma :unDivisor |  suma + unDivisor]) - self valor 
! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:52'!
valor
	^ valor! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:52'!
valor: anObject
	valor := anObject! !
